Se absolute filename in files like
    /usr/share/qemu/firmware/50-edk2-x86_64-secure.json

Bug: https://bugs.gentoo.org/766743
Patch-by: Jannik Glückert
--- a/pc-bios/descriptors/meson.build
+++ b/pc-bios/descriptors/meson.build
@@ -8,7 +8,7 @@ foreach f: [
 ]
   configure_file(input: files(f),
                  output: f,
-                 configuration: {'DATADIR': qemu_datadir},
+                 configuration: {'DATADIR': get_option('prefix') / qemu_datadir},
                  install: get_option('install_blobs'),
                  install_dir: qemu_datadir / 'firmware')
 endforeach