If SafeStack fails to build it should be disabled, not enabled.
--- a/configure
+++ b/configure
@@ -4956,7 +4956,7 @@ if test "$safe_stack" = "no"; then
   fi
 else # "$safe_stack" = ""
   # Set safe_stack to yes or no based on pre-existing flags
-  if compile_prog "-Werror" ""; then
+  if ! compile_prog "-Werror" ""; then
     safe_stack="no"
   else
     safe_stack="yes"